import 'dart:async';

class BoundStream<S, T> extends Stream<T> {
  final StreamSubscription<T> Function(Stream<S> stream, bool cancelOnError)
      _onListen;
  final Stream<S> _stream;

  @override
  bool get isBroadcast => _stream.isBroadcast;

  BoundStream(this._stream, this._onListen);

  StreamSubscription<T> listen(void onData(T event),
          {Function onError, void onDone(), bool cancelOnError}) =>
      _onListen(_stream, identical(true, cancelOnError))
        ..onData(onData)
        ..onError(onError)
        ..onDone(onDone);
}
